
#include "ell/WalkAbortionCriterion.hh"

namespace ell {
	
	
	////////////////   WAC_MaxLength  /////////////////////////////


	WAC_MaxLength::WAC_MaxLength(const size_t max)
	  :	maxStates(max) 
	{}

	bool
	WAC_MaxLength::abort(StateCollector* sc) const
	{
		if (sc->size() > maxStates)
			return true;
		else
			return false;
	}
	
	
	////////////////   WAC_MaxEnergy  /////////////////////////////
	
	
	WAC_MaxEnergy::WAC_MaxEnergy(const double max)
	  :	maxEnergy(max) 
	{}
	
	bool
	WAC_MaxEnergy::abort(StateCollector* sc) const
	{
		if (sc->getLastAdded()->getEnergy() >= maxEnergy)
			return true;
		else
			return false;
	}
	

	////////////////   WAC_MinEnergy  /////////////////////////////
	

	WAC_MinEnergy::WAC_MinEnergy(const double min) 
	  :	minEnergy(min) 
	{}

	bool
	WAC_MinEnergy::abort(StateCollector* sc) const
	{
		if (sc->getLastAdded()->getEnergy() <= minEnergy)
			return true;
		else
			return false;
	}
	
	
	////////////////   WAC_OpenEnd  /////////////////////////////
	
	
	WAC_OpenEnd::WAC_OpenEnd() 
	{}
	
	bool
	WAC_OpenEnd::abort(StateCollector* sc) const 
	{ 
		return false; 
	} 

	
} // namespace ell
